<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:48 JST 2014 -->
<TITLE>
ZooKeeper
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ZooKeeper";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/apache/zookeeper/ZooDefs.Perms.html" title="interface in org.apache.zookeeper"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/apache/zookeeper/ZooKeeper.States.html" title="enum in org.apache.zookeeper"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/apache/zookeeper/ZooKeeper.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ZooKeeper.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper</FONT>
<BR>
Class ZooKeeper</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.ZooKeeper</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>ZooKeeper</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This is the main class of ZooKeeper client library. To use a ZooKeeper
 service, an application must first instantiate an object of ZooKeeper class.
 All the iterations will be done by calling the methods of ZooKeeper class.
 The methods of this class are thread-safe unless otherwise noted.
 <p>
 Once a connection to a server is established, a session ID is assigned to the
 client. The client will send heart beats to the server periodically to keep
 the session valid.
 <p>
 The application can call ZooKeeper APIs through a client as long as the
 session ID of the client remains valid.
 <p>
 If for some reason, the client fails to send heart beats to the server for a
 prolonged period of time (exceeding the sessionTimeout value, for instance),
 the server will expire the session, and the session ID will become invalid.
 The client object will no longer be usable. To make ZooKeeper API calls, the
 application must create a new client object.
 <p>
 If the ZooKeeper server the client currently connects to fails or otherwise
 does not respond, the client will automatically try to connect to another
 server before its session ID expires. If successful, the application can
 continue to use the client.
 <p>
 The ZooKeeper API methods are either synchronous or asynchronous. Synchronous
 methods blocks until the server has responded. Asynchronous methods just queue
 the request for sending and return immediately. They take a callback object that
 will be executed either on successful execution of the request or on error with
 an appropriate return code (rc) indicating the error.
 <p>
 Some successful ZooKeeper API calls can leave watches on the "data nodes" in
 the ZooKeeper server. Other successful ZooKeeper API calls can trigger those
 watches. Once a watch is triggered, an event will be delivered to the client
 which left the watch at the first place. Each watch can be triggered only
 once. Thus, up to one event will be delivered to a client for every watch it
 leaves.
 <p>
 A client needs an object of a class implementing Watcher interface for
 processing the events delivered to the client.

 When a client drops current connection and re-connects to a server, all the
 existing watches are considered as being triggered but the undelivered events
 are lost. To emulate this, the client will generate a special event to tell
 the event handler a connection has been dropped. This special event has type
 EventNone and state sKeeperStateDisconnected.
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.States.html" title="enum in org.apache.zookeeper">ZooKeeper.States</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../org/apache/zookeeper/ClientCnxn.html" title="class in org.apache.zookeeper">ClientCnxn</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#cnxn">cnxn</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#ZOOKEEPER_CLIENT_CNXN_SOCKET">ZOOKEEPER_CLIENT_CNXN_SOCKET</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher)">ZooKeeper</A></B>(java.lang.String&nbsp;connectString,
          int&nbsp;sessionTimeout,
          <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, boolean)">ZooKeeper</A></B>(java.lang.String&nbsp;connectString,
          int&nbsp;sessionTimeout,
          <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
          boolean&nbsp;canBeReadOnly)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, long, byte[])">ZooKeeper</A></B>(java.lang.String&nbsp;connectString,
          int&nbsp;sessionTimeout,
          <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
          long&nbsp;sessionId,
          byte[]&nbsp;sessionPasswd)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, long, byte[], boolean)">ZooKeeper</A></B>(java.lang.String&nbsp;connectString,
          int&nbsp;sessionTimeout,
          <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
          long&nbsp;sessionId,
          byte[]&nbsp;sessionPasswd,
          boolean&nbsp;canBeReadOnly)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#addAuthInfo(java.lang.String, byte[])">addAuthInfo</A></B>(java.lang.String&nbsp;scheme,
            byte[]&nbsp;auth)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Add the specified scheme:auth information to this connection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#close()">close</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Close this client object.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#create(java.lang.String, byte[], java.util.List, org.apache.zookeeper.CreateMode)">create</A></B>(java.lang.String&nbsp;path,
       byte[]&nbsp;data,
       java.util.List&lt;ACL&gt;&nbsp;acl,
       <A HREF="../../../org/apache/zookeeper/CreateMode.html" title="enum in org.apache.zookeeper">CreateMode</A>&nbsp;createMode)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Create a node with the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#create(java.lang.String, byte[], java.util.List, org.apache.zookeeper.CreateMode, org.apache.zookeeper.AsyncCallback.StringCallback, java.lang.Object)">create</A></B>(java.lang.String&nbsp;path,
       byte[]&nbsp;data,
       java.util.List&lt;ACL&gt;&nbsp;acl,
       <A HREF="../../../org/apache/zookeeper/CreateMode.html" title="enum in org.apache.zookeeper">CreateMode</A>&nbsp;createMode,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.StringCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StringCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of create.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#delete(java.lang.String, int)">delete</A></B>(java.lang.String&nbsp;path,
       int&nbsp;version)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete the node with the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#delete(java.lang.String, int, org.apache.zookeeper.AsyncCallback.VoidCallback, java.lang.Object)">delete</A></B>(java.lang.String&nbsp;path,
       int&nbsp;version,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.VoidCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of delete.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;Stat</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, boolean)">exists</A></B>(java.lang.String&nbsp;path,
       boolean&nbsp;watch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the stat of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)">exists</A></B>(java.lang.String&nbsp;path,
       boolean&nbsp;watch,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of exists.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;Stat</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, org.apache.zookeeper.Watcher)">exists</A></B>(java.lang.String&nbsp;path,
       <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the stat of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)">exists</A></B>(java.lang.String&nbsp;path,
       <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of exists.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;ACL&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getACL(java.lang.String, Stat)">getACL</A></B>(java.lang.String&nbsp;path,
       Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the ACL and stat of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getACL(java.lang.String, Stat, org.apache.zookeeper.AsyncCallback.ACLCallback, java.lang.Object)">getACL</A></B>(java.lang.String&nbsp;path,
       Stat&nbsp;stat,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.ACLCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ACLCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getACL.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean)">getChildren</A></B>(java.lang.String&nbsp;path,
            boolean&nbsp;watch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the list of the children of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.Children2Callback, java.lang.Object)">getChildren</A></B>(java.lang.String&nbsp;path,
            boolean&nbsp;watch,
            <A HREF="../../../org/apache/zookeeper/AsyncCallback.Children2Callback.html" title="interface in org.apache.zookeeper">AsyncCallback.Children2Callback</A>&nbsp;cb,
            java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getChildren.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.ChildrenCallback, java.lang.Object)">getChildren</A></B>(java.lang.String&nbsp;path,
            boolean&nbsp;watch,
            <A HREF="../../../org/apache/zookeeper/AsyncCallback.ChildrenCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ChildrenCallback</A>&nbsp;cb,
            java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getChildren.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean, Stat)">getChildren</A></B>(java.lang.String&nbsp;path,
            boolean&nbsp;watch,
            Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;For the given znode path return the stat and children list.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher)">getChildren</A></B>(java.lang.String&nbsp;path,
            <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the list of the children of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.Children2Callback, java.lang.Object)">getChildren</A></B>(java.lang.String&nbsp;path,
            <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
            <A HREF="../../../org/apache/zookeeper/AsyncCallback.Children2Callback.html" title="interface in org.apache.zookeeper">AsyncCallback.Children2Callback</A>&nbsp;cb,
            java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getChildren.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.ChildrenCallback, java.lang.Object)">getChildren</A></B>(java.lang.String&nbsp;path,
            <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
            <A HREF="../../../org/apache/zookeeper/AsyncCallback.ChildrenCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ChildrenCallback</A>&nbsp;cb,
            java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getChildren.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher, Stat)">getChildren</A></B>(java.lang.String&nbsp;path,
            <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
            Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;For the given znode path return the stat and children list.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.DataCallback, java.lang.Object)">getData</A></B>(java.lang.String&nbsp;path,
        boolean&nbsp;watch,
        <A HREF="../../../org/apache/zookeeper/AsyncCallback.DataCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.DataCallback</A>&nbsp;cb,
        java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getData.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, boolean, Stat)">getData</A></B>(java.lang.String&nbsp;path,
        boolean&nbsp;watch,
        Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the data and the stat of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.DataCallback, java.lang.Object)">getData</A></B>(java.lang.String&nbsp;path,
        <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
        <A HREF="../../../org/apache/zookeeper/AsyncCallback.DataCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.DataCallback</A>&nbsp;cb,
        java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of getData.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, org.apache.zookeeper.Watcher, Stat)">getData</A></B>(java.lang.String&nbsp;path,
        <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
        Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return the data and the stat of the node of the given path.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../org/apache/zookeeper/client/ZooKeeperSaslClient.html" title="class in org.apache.zookeeper.client">ZooKeeperSaslClient</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSaslClient()">getSaslClient</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionId()">getSessionId</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The session id for this ZooKeeper client instance.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionPasswd()">getSessionPasswd</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The session password for this ZooKeeper client instance.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionTimeout()">getSessionTimeout</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The negotiated session timeout for this ZooKeeper client instance.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../org/apache/zookeeper/ZooKeeper.States.html" title="enum in org.apache.zookeeper">ZooKeeper.States</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getState()">getState</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;<A HREF="../../../org/apache/zookeeper/OpResult.html" title="class in org.apache.zookeeper">OpResult</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#multi(java.lang.Iterable)">multi</A></B>(java.lang.Iterable&lt;<A HREF="../../../org/apache/zookeeper/Op.html" title="class in org.apache.zookeeper">Op</A>&gt;&nbsp;ops)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Executes multiple ZooKeeper operations or none of them.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.util.List&lt;<A HREF="../../../org/apache/zookeeper/OpResult.html" title="class in org.apache.zookeeper">OpResult</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#multiInternal(org.apache.zookeeper.MultiTransactionRecord)">multiInternal</A></B>(<A HREF="../../../org/apache/zookeeper/MultiTransactionRecord.html" title="class in org.apache.zookeeper">MultiTransactionRecord</A>&nbsp;request)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#register(org.apache.zookeeper.Watcher)">register</A></B>(<A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Specify the default watcher for the connection (overrides the one
 specified during construction).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;Stat</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setACL(java.lang.String, java.util.List, int)">setACL</A></B>(java.lang.String&nbsp;path,
       java.util.List&lt;ACL&gt;&nbsp;acl,
       int&nbsp;version)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set the ACL for the node of the given path if such a node exists and the
 given version matches the version of the node.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setACL(java.lang.String, java.util.List, int, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)">setACL</A></B>(java.lang.String&nbsp;path,
       java.util.List&lt;ACL&gt;&nbsp;acl,
       int&nbsp;version,
       <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
       java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of setACL.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;Stat</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setData(java.lang.String, byte[], int)">setData</A></B>(java.lang.String&nbsp;path,
        byte[]&nbsp;data,
        int&nbsp;version)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Set the data for the node of the given path if such a node exists and the
 given version matches the version of the node (if the given version is
 -1, it matches any node's versions).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setData(java.lang.String, byte[], int, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)">setData</A></B>(java.lang.String&nbsp;path,
        byte[]&nbsp;data,
        int&nbsp;version,
        <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
        java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The asynchronous version of setData.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#sync(java.lang.String, org.apache.zookeeper.AsyncCallback.VoidCallback, java.lang.Object)">sync</A></B>(java.lang.String&nbsp;path,
     <A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.VoidCallback</A>&nbsp;cb,
     java.lang.Object&nbsp;ctx)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Asynchronous sync.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.net.SocketAddress</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#testableLocalSocketAddress()">testableLocalSocketAddress</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the local address to which the socket is bound.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.net.SocketAddress</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#testableRemoteSocketAddress()">testableRemoteSocketAddress</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the address to which the socket is connected.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#testableWaitForShutdown(int)">testableWaitForShutdown</A></B>(int&nbsp;wait)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Wait up to wait milliseconds for the underlying threads to shutdown.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#toString()">toString</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String representation of this ZooKeeper client.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../org/apache/zookeeper/Transaction.html" title="class in org.apache.zookeeper">Transaction</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#transaction()">transaction</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;A Transaction is a thin wrapper on the <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#multi(java.lang.Iterable)"><CODE>multi(java.lang.Iterable<org.apache.zookeeper.Op>)</CODE></A> method
 which provides a builder object that can be used to construct
 and commit an atomic set of operations.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ZOOKEEPER_CLIENT_CNXN_SOCKET"><!-- --></A><H3>
ZOOKEEPER_CLIENT_CNXN_SOCKET</H3>
<PRE>
public static final java.lang.String <B>ZOOKEEPER_CLIENT_CNXN_SOCKET</B></PRE>
<DL>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../constant-values.html#org.apache.zookeeper.ZooKeeper.ZOOKEEPER_CLIENT_CNXN_SOCKET">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="cnxn"><!-- --></A><H3>
cnxn</H3>
<PRE>
protected final <A HREF="../../../org/apache/zookeeper/ClientCnxn.html" title="class in org.apache.zookeeper">ClientCnxn</A> <B>cnxn</B></PRE>
<DL>
<DL>
</DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
ZooKeeper</H3>
<PRE>
public <B>ZooKeeper</B>(java.lang.String&nbsp;connectString,
                 int&nbsp;sessionTimeout,
                 <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)
          throws java.io.IOException</PRE>
<DL>
<DD>To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.
 <p>
 Session establishment is asynchronous. This constructor will initiate
 connection to the server and return immediately - potentially (usually)
 before the session is fully established. The watcher argument specifies
 the watcher that will be notified of any changes in state. This
 notification can come at any point before or after the constructor call
 has returned.
 <p>
 The instantiated ZooKeeper client object will pick an arbitrary server
 from the connectString and attempt to connect to it. If establishment of
 the connection fails, another server in the connect string will be tried
 (the order is non-deterministic, as we random shuffle the list), until a
 connection is established. The client will continue attempts until the
 session is explicitly closed.
 <p>
 Added in 3.2.0: An optional "chroot" suffix may also be appended to the
 connection string. This will run the client commands while interpreting
 all paths relative to this root (similar to the unix chroot command).
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>connectString</CODE> - comma separated host:port pairs, each corresponding to a zk
            server. e.g. "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002" If
            the optional chroot suffix is used the example would look
            like: "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a"
            where the client would be rooted at "/app/a" and all paths
            would be relative to this root - ie getting/setting/etc...
            "/foo/bar" would result in operations being run on
            "/app/a/foo/bar" (from the server perspective).<DD><CODE>sessionTimeout</CODE> - session timeout in milliseconds<DD><CODE>watcher</CODE> - a watcher object which will be notified of state changes, may
            also be notified for node events
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE> - in cases of network failure
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid chroot path is specified</DL>
</DL>
<HR>

<A NAME="ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, boolean)"><!-- --></A><H3>
ZooKeeper</H3>
<PRE>
public <B>ZooKeeper</B>(java.lang.String&nbsp;connectString,
                 int&nbsp;sessionTimeout,
                 <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                 boolean&nbsp;canBeReadOnly)
          throws java.io.IOException</PRE>
<DL>
<DD>To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.
 <p>
 Session establishment is asynchronous. This constructor will initiate
 connection to the server and return immediately - potentially (usually)
 before the session is fully established. The watcher argument specifies
 the watcher that will be notified of any changes in state. This
 notification can come at any point before or after the constructor call
 has returned.
 <p>
 The instantiated ZooKeeper client object will pick an arbitrary server
 from the connectString and attempt to connect to it. If establishment of
 the connection fails, another server in the connect string will be tried
 (the order is non-deterministic, as we random shuffle the list), until a
 connection is established. The client will continue attempts until the
 session is explicitly closed.
 <p>
 Added in 3.2.0: An optional "chroot" suffix may also be appended to the
 connection string. This will run the client commands while interpreting
 all paths relative to this root (similar to the unix chroot command).
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>connectString</CODE> - comma separated host:port pairs, each corresponding to a zk
            server. e.g. "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002" If
            the optional chroot suffix is used the example would look
            like: "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a"
            where the client would be rooted at "/app/a" and all paths
            would be relative to this root - ie getting/setting/etc...
            "/foo/bar" would result in operations being run on
            "/app/a/foo/bar" (from the server perspective).<DD><CODE>sessionTimeout</CODE> - session timeout in milliseconds<DD><CODE>watcher</CODE> - a watcher object which will be notified of state changes, may
            also be notified for node events<DD><CODE>canBeReadOnly</CODE> - (added in 3.4) whether the created client is allowed to go to
            read-only mode in case of partitioning. Read-only mode
            basically means that if the client can't find any majority
            servers but there's partitioned server it could reach, it
            connects to one in read-only mode, i.e. read requests are
            allowed while write requests are not. It continues seeking for
            majority in the background.
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE> - in cases of network failure
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid chroot path is specified</DL>
</DL>
<HR>

<A NAME="ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, long, byte[])"><!-- --></A><H3>
ZooKeeper</H3>
<PRE>
public <B>ZooKeeper</B>(java.lang.String&nbsp;connectString,
                 int&nbsp;sessionTimeout,
                 <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                 long&nbsp;sessionId,
                 byte[]&nbsp;sessionPasswd)
          throws java.io.IOException</PRE>
<DL>
<DD>To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.
 <p>
 Session establishment is asynchronous. This constructor will initiate
 connection to the server and return immediately - potentially (usually)
 before the session is fully established. The watcher argument specifies
 the watcher that will be notified of any changes in state. This
 notification can come at any point before or after the constructor call
 has returned.
 <p>
 The instantiated ZooKeeper client object will pick an arbitrary server
 from the connectString and attempt to connect to it. If establishment of
 the connection fails, another server in the connect string will be tried
 (the order is non-deterministic, as we random shuffle the list), until a
 connection is established. The client will continue attempts until the
 session is explicitly closed (or the session is expired by the server).
 <p>
 Added in 3.2.0: An optional "chroot" suffix may also be appended to the
 connection string. This will run the client commands while interpreting
 all paths relative to this root (similar to the unix chroot command).
 <p>
 Use <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionId()"><CODE>getSessionId()</CODE></A> and <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionPasswd()"><CODE>getSessionPasswd()</CODE></A> on an established
 client connection, these values must be passed as sessionId and
 sessionPasswd respectively if reconnecting. Otherwise, if not
 reconnecting, use the other constructor which does not require these
 parameters.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>connectString</CODE> - comma separated host:port pairs, each corresponding to a zk
            server. e.g. "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002"
            If the optional chroot suffix is used the example would look
            like: "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a"
            where the client would be rooted at "/app/a" and all paths
            would be relative to this root - ie getting/setting/etc...
            "/foo/bar" would result in operations being run on
            "/app/a/foo/bar" (from the server perspective).<DD><CODE>sessionTimeout</CODE> - session timeout in milliseconds<DD><CODE>watcher</CODE> - a watcher object which will be notified of state changes, may
            also be notified for node events<DD><CODE>sessionId</CODE> - specific session id to use if reconnecting<DD><CODE>sessionPasswd</CODE> - password for this session
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE> - in cases of network failure
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid chroot path is specified
<DD><CODE>java.lang.IllegalArgumentException</CODE> - for an invalid list of ZooKeeper hosts</DL>
</DL>
<HR>

<A NAME="ZooKeeper(java.lang.String, int, org.apache.zookeeper.Watcher, long, byte[], boolean)"><!-- --></A><H3>
ZooKeeper</H3>
<PRE>
public <B>ZooKeeper</B>(java.lang.String&nbsp;connectString,
                 int&nbsp;sessionTimeout,
                 <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                 long&nbsp;sessionId,
                 byte[]&nbsp;sessionPasswd,
                 boolean&nbsp;canBeReadOnly)
          throws java.io.IOException</PRE>
<DL>
<DD>To create a ZooKeeper client object, the application needs to pass a
 connection string containing a comma separated list of host:port pairs,
 each corresponding to a ZooKeeper server.
 <p>
 Session establishment is asynchronous. This constructor will initiate
 connection to the server and return immediately - potentially (usually)
 before the session is fully established. The watcher argument specifies
 the watcher that will be notified of any changes in state. This
 notification can come at any point before or after the constructor call
 has returned.
 <p>
 The instantiated ZooKeeper client object will pick an arbitrary server
 from the connectString and attempt to connect to it. If establishment of
 the connection fails, another server in the connect string will be tried
 (the order is non-deterministic, as we random shuffle the list), until a
 connection is established. The client will continue attempts until the
 session is explicitly closed (or the session is expired by the server).
 <p>
 Added in 3.2.0: An optional "chroot" suffix may also be appended to the
 connection string. This will run the client commands while interpreting
 all paths relative to this root (similar to the unix chroot command).
 <p>
 Use <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionId()"><CODE>getSessionId()</CODE></A> and <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getSessionPasswd()"><CODE>getSessionPasswd()</CODE></A> on an established
 client connection, these values must be passed as sessionId and
 sessionPasswd respectively if reconnecting. Otherwise, if not
 reconnecting, use the other constructor which does not require these
 parameters.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>connectString</CODE> - comma separated host:port pairs, each corresponding to a zk
            server. e.g. "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002"
            If the optional chroot suffix is used the example would look
            like: "127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a"
            where the client would be rooted at "/app/a" and all paths
            would be relative to this root - ie getting/setting/etc...
            "/foo/bar" would result in operations being run on
            "/app/a/foo/bar" (from the server perspective).<DD><CODE>sessionTimeout</CODE> - session timeout in milliseconds<DD><CODE>watcher</CODE> - a watcher object which will be notified of state changes, may
            also be notified for node events<DD><CODE>sessionId</CODE> - specific session id to use if reconnecting<DD><CODE>sessionPasswd</CODE> - password for this session<DD><CODE>canBeReadOnly</CODE> - (added in 3.4) whether the created client is allowed to go to
            read-only mode in case of partitioning. Read-only mode
            basically means that if the client can't find any majority
            servers but there's partitioned server it could reach, it
            connects to one in read-only mode, i.e. read requests are
            allowed while write requests are not. It continues seeking for
            majority in the background.
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE> - in cases of network failure
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid chroot path is specified</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getSaslClient()"><!-- --></A><H3>
getSaslClient</H3>
<PRE>
public <A HREF="../../../org/apache/zookeeper/client/ZooKeeperSaslClient.html" title="class in org.apache.zookeeper.client">ZooKeeperSaslClient</A> <B>getSaslClient</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionId()"><!-- --></A><H3>
getSessionId</H3>
<PRE>
public long <B>getSessionId</B>()</PRE>
<DL>
<DD>The session id for this ZooKeeper client instance. The value returned is
 not valid until the client connects to a server and may change after a
 re-connect.

 This method is NOT thread safe
<P>
<DD><DL>

<DT><B>Returns:</B><DD>current session id</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionPasswd()"><!-- --></A><H3>
getSessionPasswd</H3>
<PRE>
public byte[] <B>getSessionPasswd</B>()</PRE>
<DL>
<DD>The session password for this ZooKeeper client instance. The value
 returned is not valid until the client connects to a server and may
 change after a re-connect.

 This method is NOT thread safe
<P>
<DD><DL>

<DT><B>Returns:</B><DD>current session password</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionTimeout()"><!-- --></A><H3>
getSessionTimeout</H3>
<PRE>
public int <B>getSessionTimeout</B>()</PRE>
<DL>
<DD>The negotiated session timeout for this ZooKeeper client instance. The
 value returned is not valid until the client connects to a server and
 may change after a re-connect.

 This method is NOT thread safe
<P>
<DD><DL>

<DT><B>Returns:</B><DD>current session timeout</DL>
</DD>
</DL>
<HR>

<A NAME="addAuthInfo(java.lang.String, byte[])"><!-- --></A><H3>
addAuthInfo</H3>
<PRE>
public void <B>addAuthInfo</B>(java.lang.String&nbsp;scheme,
                        byte[]&nbsp;auth)</PRE>
<DL>
<DD>Add the specified scheme:auth information to this connection.

 This method is NOT thread safe
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>scheme</CODE> - <DD><CODE>auth</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="register(org.apache.zookeeper.Watcher)"><!-- --></A><H3>
register</H3>
<PRE>
public void <B>register</B>(<A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</PRE>
<DL>
<DD>Specify the default watcher for the connection (overrides the one
 specified during construction).
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>watcher</CODE> - </DL>
</DD>
</DL>
<HR>

<A NAME="close()"><!-- --></A><H3>
close</H3>
<PRE>
public void <B>close</B>()
           throws java.lang.InterruptedException</PRE>
<DL>
<DD>Close this client object. Once the client is closed, its session becomes
 invalid. All the ephemeral nodes in the ZooKeeper server associated with
 the session will be removed. The watches left on those nodes (and on
 their parents) will be triggered.
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="create(java.lang.String, byte[], java.util.List, org.apache.zookeeper.CreateMode)"><!-- --></A><H3>
create</H3>
<PRE>
public java.lang.String <B>create</B>(java.lang.String&nbsp;path,
                               byte[]&nbsp;data,
                               java.util.List&lt;ACL&gt;&nbsp;acl,
                               <A HREF="../../../org/apache/zookeeper/CreateMode.html" title="enum in org.apache.zookeeper">CreateMode</A>&nbsp;createMode)
                        throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                               java.lang.InterruptedException</PRE>
<DL>
<DD>Create a node with the given path. The node data will be the given data,
 and node acl will be the given acl.
 <p>
 The flags argument specifies whether the created node will be ephemeral
 or not.
 <p>
 An ephemeral node will be removed by the ZooKeeper automatically when the
 session associated with the creation of the node expires.
 <p>
 The flags argument can also specify to create a sequential node. The
 actual path name of a sequential node will be the given path plus a
 suffix "i" where i is the current sequential number of the node. The sequence
 number is always fixed length of 10 digits, 0 padded. Once
 such a node is created, the sequential number will be incremented by one.
 <p>
 If a node with the same actual path already exists in the ZooKeeper, a
 KeeperException with error code KeeperException.NodeExists will be
 thrown. Note that since a different actual path is used for each
 invocation of creating sequential node with the same path argument, the
 call will never throw "file exists" KeeperException.
 <p>
 If the parent node does not exist in the ZooKeeper, a KeeperException
 with error code KeeperException.NoNode will be thrown.
 <p>
 An ephemeral node cannot have children. If the parent node of the given
 path is ephemeral, a KeeperException with error code
 KeeperException.NoChildrenForEphemerals will be thrown.
 <p>
 This operation, if successful, will trigger all the watches left on the
 node of the given path by exists and getData API calls, and the watches
 left on the parent node by getChildren API calls.
 <p>
 If a node is created successfully, the ZooKeeper server will trigger the
 watches on the path left by exists calls, and the watches on the parent
 of the node by getChildren calls.
 <p>
 The maximum allowable size of the data array is 1 MB (1,048,576 bytes).
 Arrays larger than this will cause a KeeperExecption to be thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path for the node<DD><CODE>data</CODE> - the initial data for the node<DD><CODE>acl</CODE> - the acl for the node<DD><CODE>createMode</CODE> - specifying whether the node to be created is ephemeral
                and/or sequential
<DT><B>Returns:</B><DD>the actual path of the created node
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - if the server returns a non-zero error code
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.InvalidACLException.html" title="class in org.apache.zookeeper">KeeperException.InvalidACLException</A></CODE> - if the ACL is invalid, null, or empty
<DD><CODE>java.lang.InterruptedException</CODE> - if the transaction is interrupted
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="create(java.lang.String, byte[], java.util.List, org.apache.zookeeper.CreateMode, org.apache.zookeeper.AsyncCallback.StringCallback, java.lang.Object)"><!-- --></A><H3>
create</H3>
<PRE>
public void <B>create</B>(java.lang.String&nbsp;path,
                   byte[]&nbsp;data,
                   java.util.List&lt;ACL&gt;&nbsp;acl,
                   <A HREF="../../../org/apache/zookeeper/CreateMode.html" title="enum in org.apache.zookeeper">CreateMode</A>&nbsp;createMode,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.StringCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StringCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of create.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#create(java.lang.String, byte[], java.util.List, org.apache.zookeeper.CreateMode)"><CODE>create(String, byte[], List, CreateMode)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="delete(java.lang.String, int)"><!-- --></A><H3>
delete</H3>
<PRE>
public void <B>delete</B>(java.lang.String&nbsp;path,
                   int&nbsp;version)
            throws java.lang.InterruptedException,
                   <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></PRE>
<DL>
<DD>Delete the node with the given path. The call will succeed if such a node
 exists, and the given version matches the node's version (if the given
 version is -1, it matches any node's versions).
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if the nodes does not exist.
 <p>
 A KeeperException with error code KeeperException.BadVersion will be
 thrown if the given version does not match the node's version.
 <p>
 A KeeperException with error code KeeperException.NotEmpty will be thrown
 if the node has children.
 <p>
 This operation, if successful, will trigger all the watches on the node
 of the given path left by exists API calls, and the watches on the parent
 node left by getChildren API calls.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path of the node to be deleted.<DD><CODE>version</CODE> - the expected node version.
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - IF the server transaction is interrupted
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero
   return code.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="multi(java.lang.Iterable)"><!-- --></A><H3>
multi</H3>
<PRE>
public java.util.List&lt;<A HREF="../../../org/apache/zookeeper/OpResult.html" title="class in org.apache.zookeeper">OpResult</A>&gt; <B>multi</B>(java.lang.Iterable&lt;<A HREF="../../../org/apache/zookeeper/Op.html" title="class in org.apache.zookeeper">Op</A>&gt;&nbsp;ops)
                               throws java.lang.InterruptedException,
                                      <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></PRE>
<DL>
<DD>Executes multiple ZooKeeper operations or none of them.
 <p>
 On success, a list of results is returned.
 On failure, an exception is raised which contains partial results and
 error details, see <A HREF="../../../org/apache/zookeeper/KeeperException.html#getResults()"><CODE>KeeperException.getResults()</CODE></A>
 <p>
 Note: The maximum allowable size of all of the data arrays in all of
 the setData operations in this single request is typically 1 MB
 (1,048,576 bytes). This limit is specified on the server via
 <a href="http://zookeeper.apache.org/doc/current/zookeeperAdmin.html#Unsafe+Options">jute.maxbuffer</a>.
 Requests larger than this will cause a KeeperException to be
 thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>ops</CODE> - An iterable that contains the operations to be done.
 These should be created using the factory methods on <A HREF="../../../org/apache/zookeeper/Op.html" title="class in org.apache.zookeeper"><CODE>Op</CODE></A>.
<DT><B>Returns:</B><DD>A list of results, one for each input Op, the order of
 which exactly matches the order of the <code>ops</code> input
 operations.
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the operation was interrupted.
 The operation may or may not have succeeded, but will not have
 partially succeeded if this exception is thrown.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the operation could not be completed
 due to some error in doing one of the specified ops.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified<DT><B>Since:</B></DT>
  <DD>3.4.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="multiInternal(org.apache.zookeeper.MultiTransactionRecord)"><!-- --></A><H3>
multiInternal</H3>
<PRE>
protected java.util.List&lt;<A HREF="../../../org/apache/zookeeper/OpResult.html" title="class in org.apache.zookeeper">OpResult</A>&gt; <B>multiInternal</B>(<A HREF="../../../org/apache/zookeeper/MultiTransactionRecord.html" title="class in org.apache.zookeeper">MultiTransactionRecord</A>&nbsp;request)
                                          throws java.lang.InterruptedException,
                                                 <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="transaction()"><!-- --></A><H3>
transaction</H3>
<PRE>
public <A HREF="../../../org/apache/zookeeper/Transaction.html" title="class in org.apache.zookeeper">Transaction</A> <B>transaction</B>()</PRE>
<DL>
<DD>A Transaction is a thin wrapper on the <A HREF="../../../org/apache/zookeeper/ZooKeeper.html#multi(java.lang.Iterable)"><CODE>multi(java.lang.Iterable<org.apache.zookeeper.Op>)</CODE></A> method
 which provides a builder object that can be used to construct
 and commit an atomic set of operations.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>a Transaction builder object<DT><B>Since:</B></DT>
  <DD>3.4.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="delete(java.lang.String, int, org.apache.zookeeper.AsyncCallback.VoidCallback, java.lang.Object)"><!-- --></A><H3>
delete</H3>
<PRE>
public void <B>delete</B>(java.lang.String&nbsp;path,
                   int&nbsp;version,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.VoidCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of delete.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#delete(java.lang.String, int)"><CODE>delete(String, int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="exists(java.lang.String, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
exists</H3>
<PRE>
public Stat <B>exists</B>(java.lang.String&nbsp;path,
                   <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)
            throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                   java.lang.InterruptedException</PRE>
<DL>
<DD>Return the stat of the node of the given path. Return null if no such a
 node exists.
 <p>
 If the watch is non-null and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch will be
 triggered by a successful operation that creates/delete the node or sets
 the data on the node.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the node path<DD><CODE>watcher</CODE> - explicit watcher
<DT><B>Returns:</B><DD>the stat of the node of the given path; return null if no such a
         node exists.
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="exists(java.lang.String, boolean)"><!-- --></A><H3>
exists</H3>
<PRE>
public Stat <B>exists</B>(java.lang.String&nbsp;path,
                   boolean&nbsp;watch)
            throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                   java.lang.InterruptedException</PRE>
<DL>
<DD>Return the stat of the node of the given path. Return null if no such a
 node exists.
 <p>
 If the watch is true and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch will be
 triggered by a successful operation that creates/delete the node or sets
 the data on the node.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the node path<DD><CODE>watch</CODE> - whether need to watch this node
<DT><B>Returns:</B><DD>the stat of the node of the given path; return null if no such a
         node exists.
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.</DL>
</DD>
</DL>
<HR>

<A NAME="exists(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)"><!-- --></A><H3>
exists</H3>
<PRE>
public void <B>exists</B>(java.lang.String&nbsp;path,
                   <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of exists.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, org.apache.zookeeper.Watcher)"><CODE>exists(String, Watcher)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="exists(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)"><!-- --></A><H3>
exists</H3>
<PRE>
public void <B>exists</B>(java.lang.String&nbsp;path,
                   boolean&nbsp;watch,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of exists.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#exists(java.lang.String, boolean)"><CODE>exists(String, boolean)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getData(java.lang.String, org.apache.zookeeper.Watcher, Stat)"><!-- --></A><H3>
getData</H3>
<PRE>
public byte[] <B>getData</B>(java.lang.String&nbsp;path,
                      <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                      Stat&nbsp;stat)
               throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                      java.lang.InterruptedException</PRE>
<DL>
<DD>Return the data and the stat of the node of the given path.
 <p>
 If the watch is non-null and the call is successful (no exception is
 thrown), a watch will be left on the node with the given path. The watch
 will be triggered by a successful operation that sets data on the node, or
 deletes the node.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the given path<DD><CODE>watcher</CODE> - explicit watcher<DD><CODE>stat</CODE> - the stat of the node
<DT><B>Returns:</B><DD>the data of the node
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="getData(java.lang.String, boolean, Stat)"><!-- --></A><H3>
getData</H3>
<PRE>
public byte[] <B>getData</B>(java.lang.String&nbsp;path,
                      boolean&nbsp;watch,
                      Stat&nbsp;stat)
               throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                      java.lang.InterruptedException</PRE>
<DL>
<DD>Return the data and the stat of the node of the given path.
 <p>
 If the watch is true and the call is successful (no exception is
 thrown), a watch will be left on the node with the given path. The watch
 will be triggered by a successful operation that sets data on the node, or
 deletes the node.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the given path<DD><CODE>watch</CODE> - whether need to watch this node<DD><CODE>stat</CODE> - the stat of the node
<DT><B>Returns:</B><DD>the data of the node
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.</DL>
</DD>
</DL>
<HR>

<A NAME="getData(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.DataCallback, java.lang.Object)"><!-- --></A><H3>
getData</H3>
<PRE>
public void <B>getData</B>(java.lang.String&nbsp;path,
                    <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                    <A HREF="../../../org/apache/zookeeper/AsyncCallback.DataCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.DataCallback</A>&nbsp;cb,
                    java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getData.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, org.apache.zookeeper.Watcher, Stat)"><CODE>getData(String, Watcher, Stat)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getData(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.DataCallback, java.lang.Object)"><!-- --></A><H3>
getData</H3>
<PRE>
public void <B>getData</B>(java.lang.String&nbsp;path,
                    boolean&nbsp;watch,
                    <A HREF="../../../org/apache/zookeeper/AsyncCallback.DataCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.DataCallback</A>&nbsp;cb,
                    java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getData.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getData(java.lang.String, boolean, Stat)"><CODE>getData(String, boolean, Stat)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="setData(java.lang.String, byte[], int)"><!-- --></A><H3>
setData</H3>
<PRE>
public Stat <B>setData</B>(java.lang.String&nbsp;path,
                    byte[]&nbsp;data,
                    int&nbsp;version)
             throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                    java.lang.InterruptedException</PRE>
<DL>
<DD>Set the data for the node of the given path if such a node exists and the
 given version matches the version of the node (if the given version is
 -1, it matches any node's versions). Return the stat of the node.
 <p>
 This operation, if successful, will trigger all the watches on the node
 of the given path left by getData calls.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
 <p>
 A KeeperException with error code KeeperException.BadVersion will be
 thrown if the given version does not match the node's version.
 <p>
 The maximum allowable size of the data array is 1 MB (1,048,576 bytes).
 Arrays larger than this will cause a KeeperException to be thrown.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path of the node<DD><CODE>data</CODE> - the data to set<DD><CODE>version</CODE> - the expected matching version
<DT><B>Returns:</B><DD>the state of the node
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="setData(java.lang.String, byte[], int, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)"><!-- --></A><H3>
setData</H3>
<PRE>
public void <B>setData</B>(java.lang.String&nbsp;path,
                    byte[]&nbsp;data,
                    int&nbsp;version,
                    <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
                    java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of setData.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setData(java.lang.String, byte[], int)"><CODE>setData(String, byte[], int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getACL(java.lang.String, Stat)"><!-- --></A><H3>
getACL</H3>
<PRE>
public java.util.List&lt;ACL&gt; <B>getACL</B>(java.lang.String&nbsp;path,
                                  Stat&nbsp;stat)
                           throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                                  java.lang.InterruptedException</PRE>
<DL>
<DD>Return the ACL and stat of the node of the given path.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the given path for the node<DD><CODE>stat</CODE> - the stat of the node will be copied to this parameter.
<DT><B>Returns:</B><DD>the ACL array of the given node.
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="getACL(java.lang.String, Stat, org.apache.zookeeper.AsyncCallback.ACLCallback, java.lang.Object)"><!-- --></A><H3>
getACL</H3>
<PRE>
public void <B>getACL</B>(java.lang.String&nbsp;path,
                   Stat&nbsp;stat,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.ACLCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ACLCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getACL.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getACL(java.lang.String, Stat)"><CODE>getACL(String, Stat)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="setACL(java.lang.String, java.util.List, int)"><!-- --></A><H3>
setACL</H3>
<PRE>
public Stat <B>setACL</B>(java.lang.String&nbsp;path,
                   java.util.List&lt;ACL&gt;&nbsp;acl,
                   int&nbsp;version)
            throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                   java.lang.InterruptedException</PRE>
<DL>
<DD>Set the ACL for the node of the given path if such a node exists and the
 given version matches the version of the node. Return the stat of the
 node.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
 <p>
 A KeeperException with error code KeeperException.BadVersion will be
 thrown if the given version does not match the node's version.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>acl</CODE> - <DD><CODE>version</CODE> - 
<DT><B>Returns:</B><DD>the stat of the node.
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.InvalidACLException.html" title="class in org.apache.zookeeper">KeeperException.InvalidACLException</A></CODE> - If the acl is invalide.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="setACL(java.lang.String, java.util.List, int, org.apache.zookeeper.AsyncCallback.StatCallback, java.lang.Object)"><!-- --></A><H3>
setACL</H3>
<PRE>
public void <B>setACL</B>(java.lang.String&nbsp;path,
                   java.util.List&lt;ACL&gt;&nbsp;acl,
                   int&nbsp;version,
                   <A HREF="../../../org/apache/zookeeper/AsyncCallback.StatCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.StatCallback</A>&nbsp;cb,
                   java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of setACL.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#setACL(java.lang.String, java.util.List, int)"><CODE>setACL(String, List, int)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public java.util.List&lt;java.lang.String&gt; <B>getChildren</B>(java.lang.String&nbsp;path,
                                                    <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)
                                             throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                                                    java.lang.InterruptedException</PRE>
<DL>
<DD>Return the list of the children of the node of the given path.
 <p>
 If the watch is non-null and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch willbe
 triggered by a successful operation that deletes the node of the given
 path or creates/delete a child under the node.
 <p>
 The list of children returned is not sorted and no guarantee is provided
 as to its natural or lexical order.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>watcher</CODE> - explicit watcher
<DT><B>Returns:</B><DD>an unordered array of children of the node with the given path
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, boolean)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public java.util.List&lt;java.lang.String&gt; <B>getChildren</B>(java.lang.String&nbsp;path,
                                                    boolean&nbsp;watch)
                                             throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                                                    java.lang.InterruptedException</PRE>
<DL>
<DD>Return the list of the children of the node of the given path.
 <p>
 If the watch is true and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch willbe
 triggered by a successful operation that deletes the node of the given
 path or creates/delete a child under the node.
 <p>
 The list of children returned is not sorted and no guarantee is provided
 as to its natural or lexical order.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>watch</CODE> - 
<DT><B>Returns:</B><DD>an unordered array of children of the node with the given path
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.</DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.ChildrenCallback, java.lang.Object)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public void <B>getChildren</B>(java.lang.String&nbsp;path,
                        <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                        <A HREF="../../../org/apache/zookeeper/AsyncCallback.ChildrenCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ChildrenCallback</A>&nbsp;cb,
                        java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getChildren.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher)"><CODE>getChildren(String, Watcher)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.ChildrenCallback, java.lang.Object)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public void <B>getChildren</B>(java.lang.String&nbsp;path,
                        boolean&nbsp;watch,
                        <A HREF="../../../org/apache/zookeeper/AsyncCallback.ChildrenCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.ChildrenCallback</A>&nbsp;cb,
                        java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getChildren.
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean)"><CODE>getChildren(String, boolean)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, org.apache.zookeeper.Watcher, Stat)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public java.util.List&lt;java.lang.String&gt; <B>getChildren</B>(java.lang.String&nbsp;path,
                                                    <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                                                    Stat&nbsp;stat)
                                             throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                                                    java.lang.InterruptedException</PRE>
<DL>
<DD>For the given znode path return the stat and children list.
 <p>
 If the watch is non-null and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch willbe
 triggered by a successful operation that deletes the node of the given
 path or creates/delete a child under the node.
 <p>
 The list of children returned is not sorted and no guarantee is provided
 as to its natural or lexical order.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>watcher</CODE> - explicit watcher<DD><CODE>stat</CODE> - stat of the znode designated by path
<DT><B>Returns:</B><DD>an unordered array of children of the node with the given path
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero error code.
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, boolean, Stat)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public java.util.List&lt;java.lang.String&gt; <B>getChildren</B>(java.lang.String&nbsp;path,
                                                    boolean&nbsp;watch,
                                                    Stat&nbsp;stat)
                                             throws <A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A>,
                                                    java.lang.InterruptedException</PRE>
<DL>
<DD>For the given znode path return the stat and children list.
 <p>
 If the watch is true and the call is successful (no exception is thrown),
 a watch will be left on the node with the given path. The watch willbe
 triggered by a successful operation that deletes the node of the given
 path or creates/delete a child under the node.
 <p>
 The list of children returned is not sorted and no guarantee is provided
 as to its natural or lexical order.
 <p>
 A KeeperException with error code KeeperException.NoNode will be thrown
 if no node with the given path exists.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>watch</CODE> - <DD><CODE>stat</CODE> - stat of the znode designated by path
<DT><B>Returns:</B><DD>an unordered array of children of the node with the given path
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE> - If the server transaction is interrupted.
<DD><CODE><A HREF="../../../org/apache/zookeeper/KeeperException.html" title="class in org.apache.zookeeper">KeeperException</A></CODE> - If the server signals an error with a non-zero
  error code.<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, org.apache.zookeeper.Watcher, org.apache.zookeeper.AsyncCallback.Children2Callback, java.lang.Object)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public void <B>getChildren</B>(java.lang.String&nbsp;path,
                        <A HREF="../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher,
                        <A HREF="../../../org/apache/zookeeper/AsyncCallback.Children2Callback.html" title="interface in org.apache.zookeeper">AsyncCallback.Children2Callback</A>&nbsp;cb,
                        java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getChildren.
<P>
<DD><DL>
<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, org.apache.zookeeper.Watcher, Stat)"><CODE>getChildren(String, Watcher, Stat)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, boolean, org.apache.zookeeper.AsyncCallback.Children2Callback, java.lang.Object)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public void <B>getChildren</B>(java.lang.String&nbsp;path,
                        boolean&nbsp;watch,
                        <A HREF="../../../org/apache/zookeeper/AsyncCallback.Children2Callback.html" title="interface in org.apache.zookeeper">AsyncCallback.Children2Callback</A>&nbsp;cb,
                        java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>The asynchronous version of getChildren.
<P>
<DD><DL>
<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
<DT><B>See Also:</B><DD><A HREF="../../../org/apache/zookeeper/ZooKeeper.html#getChildren(java.lang.String, boolean, Stat)"><CODE>getChildren(String, boolean, Stat)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="sync(java.lang.String, org.apache.zookeeper.AsyncCallback.VoidCallback, java.lang.Object)"><!-- --></A><H3>
sync</H3>
<PRE>
public void <B>sync</B>(java.lang.String&nbsp;path,
                 <A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper">AsyncCallback.VoidCallback</A>&nbsp;cb,
                 java.lang.Object&nbsp;ctx)</PRE>
<DL>
<DD>Asynchronous sync. Flushes channel between process and leader.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - <DD><CODE>cb</CODE> - a handler for the callback<DD><CODE>ctx</CODE> - context to be provided to the callback
<DT><B>Throws:</B>
<DD><CODE>java.lang.IllegalArgumentException</CODE> - if an invalid path is specified</DL>
</DD>
</DL>
<HR>

<A NAME="getState()"><!-- --></A><H3>
getState</H3>
<PRE>
public <A HREF="../../../org/apache/zookeeper/ZooKeeper.States.html" title="enum in org.apache.zookeeper">ZooKeeper.States</A> <B>getState</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="toString()"><!-- --></A><H3>
toString</H3>
<PRE>
public java.lang.String <B>toString</B>()</PRE>
<DL>
<DD>String representation of this ZooKeeper client. Suitable for things
 like logging.
 
 Do NOT count on the format of this string, it may change without
 warning.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE>toString</CODE> in class <CODE>java.lang.Object</CODE></DL>
</DD>
<DD><DL>
<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="testableWaitForShutdown(int)"><!-- --></A><H3>
testableWaitForShutdown</H3>
<PRE>
protected boolean <B>testableWaitForShutdown</B>(int&nbsp;wait)
                                   throws java.lang.InterruptedException</PRE>
<DL>
<DD>Wait up to wait milliseconds for the underlying threads to shutdown.
 THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>wait</CODE> - max wait in milliseconds
<DT><B>Returns:</B><DD>true iff all threads are shutdown, otw false
<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE><DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="testableRemoteSocketAddress()"><!-- --></A><H3>
testableRemoteSocketAddress</H3>
<PRE>
protected java.net.SocketAddress <B>testableRemoteSocketAddress</B>()</PRE>
<DL>
<DD>Returns the address to which the socket is connected. Useful for testing
 against an ensemble - test client may need to know which server
 to shutdown if interested in verifying that the code handles
 disconnection/reconnection correctly.
 THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
<P>
<DD><DL>

<DT><B>Returns:</B><DD>ip address of the remote side of the connection or null if
         not connected<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<HR>

<A NAME="testableLocalSocketAddress()"><!-- --></A><H3>
testableLocalSocketAddress</H3>
<PRE>
protected java.net.SocketAddress <B>testableLocalSocketAddress</B>()</PRE>
<DL>
<DD>Returns the local address to which the socket is bound.
 THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
<P>
<DD><DL>

<DT><B>Returns:</B><DD>ip address of the remote side of the connection or null if
         not connected<DT><B>Since:</B></DT>
  <DD>3.3.0</DD>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/apache/zookeeper/ZooDefs.Perms.html" title="interface in org.apache.zookeeper"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/apache/zookeeper/ZooKeeper.States.html" title="enum in org.apache.zookeeper"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/apache/zookeeper/ZooKeeper.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ZooKeeper.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
